''*************************************
''*  Altair Simulator Memory v1.4     *
''*  (C) 2008 Michael Rychlik         *
''*************************************

' v1.0 - 01 Oct 2007 - original version
' v1.1 - 09 Dec 2007 - No change just bump verion inline with other modules
' v1.2 - 09 Mar 2008 - No change, just bump version 
' v1.3 - 20 Mar 2008 - Added Altair ROM area loaded from file BOOTDSK.COM
'                      ROM is accessed by CBIOSX to get the boot up disk number
'                      otherwise is not usd as we have all of CP/M loaded already
'                    - Added the instructions set test program (T8080.com)
'                      to the Transien Program Area (TPA). 
' v1.4 - 21 Mar 2008 - Bumped version.
                                      
CON

TPA = $100

  'The following taken from the SIMH Altair simulator cfgccp.lib
  'WARNING !!! Change this is altair_ios also if you change it here !!!

  msize =  24          ' adjust per installed system memory (K bytes)
  bioslen = $d00       ' adjust as bios changes are made (if necessary)
  ccplen = $800        ' cp/m constant
  bdoslen = $e00       ' cp/m constant

  ' cp/m image size (rounded up to next 1k boundary)
  cpmlen = (ccplen + bdoslen + bioslen + $3ff) / $400
  ccpph  = (msize - cpmlen) * 1024         ' ccp start address
  bdosph = ccpph + ccplen                  ' bdos start address
  biosph = ccpph + ccplen + bdoslen        ' bios start address

  bdos   = bdosph + 6                      ' Entry point for BDOS
  
  ' 8080 jmp op code
  jmp_ = %11_000_011

  ' Address of the Transient Program Area (TPA)
  tpa_addr = $100
     
VAR     

long length
long idx

VAR


PUB init : Success
{
  
  bytemove(@Buff2, @Buff1, 100) 'Copy Buff1 to Buff2

  'Move our loaded program from where ever it is to the CPM Transient Program Area (TPA)
  length := @tpa_file_end - @tpa_file

  
  repeat  idx from 0 to length - 1
    ram_8080.byte[TPA + idx] := prog_file.byte[idx]

  'Move BDOS from where ever it is to the BDOS start address
  repeat  idx from 0 to bdoslen - 1
    ram_8080.byte[bdosph + idx] := bdos_file.byte[idx]

  'Move BIOS from where ever it is to the BDOS start address
  repeat  idx from 0 to bioslen - 1
    ram_8080.byte[biosph + idx] := bios_file.byte[idx]
}





  
PUB get_ram_base : ram_base
  ram_base := @ram_8080

PUB get_rom_base : rom_base
  rom_base := @rom_8080

PUB get_size : size
  size := @ram_8080_end - @ram_8080



DAT
'Example 8080 program in a DAT section, this could be loaded from a file
'N.B. This section is shared amoung all the cogs using this object
'Put an 8085 test program in RAM
ram_8080
        'Under CPM programs are loaded at 100H so fill out low RAM first
{{         BYTE jmp_                        ' At 0000H Jump (jmp_) to  CBIOSX
         BYTE biosph & $FF
         BYTE (biosph >> 8) & $FF        
}}

         BYTE jmp_                        ' At 0000H Jump (jmp_) to  TPA
         BYTE tpa_addr & $FF
         BYTE (tpa_addr >> 8) & $FF        

         BYTE 0,0
         BYTE jmp_                        ' At 0005H we have a jump in to BDOS
         BYTE bdos & $FF
         BYTE (bdos >> 8) & $FF
         BYTE 0,0,0,0,0,0,0,0


         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

         'Load CPM program at 100H, the Transient Program Area
         'This file must be exactly the size required to fill the TPA (15104 bytes for a 24K RAM system)
         'T8080.COM is an 8080 instruction set test, which boots CPM if all OK else halts the cpu
tpa_file     file "T8080.COM"
tpa_file_end

         'Load CP/Ms Console Command Processor
ccp_file      file "ccp.com"

         'Load CP/Ms Basic Disk Operating System
bdos_file     file "bdos.com"
bdos_file_end
         
         'Load CP/Ms Customised Basic IO System
bios_file     file "cbiosx.com"
bios_file_end         

ram_8080_end

         'Load Altair boot rom...
rom_8080         file "DSKBOOT.COM"
rom_8080_end